def gradient(f, x, d):
    """ Calculates the gradient of function f
        at point x using an interval of width
        2 times d.
        Assumes f is a function that takes one
        numerical parameter, x is a number and
        d is a number.
        Depending on the function f, some values
        of x and d may lead to errors. """
    return (f(x + d) - f(x - d)) / (2 * d)
